%     VIRTUAL UD - программа для получения эффективных свойств однонаправленного жгута
%     Copyright (C) 2020  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

clear all; %#ok<CLALL>
clc;
more off;

% #######################################################################################################
% ##                                                                                                   ##
% ##                                        НАСТРОЙКИ ПРОГРАММЫ                                        ##
% ##                                                                                                   ##
% #######################################################################################################

% Для включения возможности вывода информации на русском языке при выполнении программы в среде GNU Octave
% необходимо добавить в файл C:\Octave\Octave-4.4.0\share\octave\site\m\startup\octaverc  следующую строку:
% system("chcp 1251",1);

% ----------------------------------- Параметры ячейки периодичности ------------------------------------

V_resin                    = 0.45;        % Объемная доля связующего
Fiber_Diameter             = 5e-003;      % Диаметр волокна

Fiber_Packing              = 'HEXAGONAL'; % HEXAGONAL | SQUARE    % Модель размещения волокон (см. руководство пользователя)
RVE_Thickness_Model        = 'AUTO';      % AUTO | SPECIFY        % Толщина ячейки периодичности

    % AUTO - толщина ячейки периодичности вычисляется автоматически
    % SPECIFY - толщина ячейки периодичности явно задается пользователем

    % Если RVE_Thickness_Model == SPECIFY
    RVE_Thickness_Value     = 1e-003;    % Толщина ячейки периодичности

% ------------------------------------------- Параметры сетки -------------------------------------------

Element_Order              = 'LINEAR'; % LINEAR | QUADRATIC    % Порядок конечных элементов
Mesh_Seed_Parameter        = 10; % Параметр густоты сетки (число конечных элементов по контуру целого волокна будет составлять 12*Mesh_Seed_Parameter в случае Fiber_Packing = HEXAGONAL и 8*Mesh_Seed_Parameter в случае Fiber_Packing = SQUARE)
N_Elements_High            = 8; % Рекомендуемое пользователем число конечных элементов по толщине ячейки периодичности (используется, если RVE_Thickness_Model == SPECIFY)
Element_Critical_Ratio     = 10; % Максимально допустимое соотношение сторон конечного элемента

% -------------------------------- Параметры массива ячеек периодичности --------------------------------

RVE_Array_1                = 1; % Число ячеек по направлению 1
RVE_Array_2                = 1; % Число ячеек по направлению 2
RVE_Array_3                = 1; % Число ячеек по направлению 3

% ----------------------------------------- Параметры расчета -------------------------------------------

Analysis_Type              = 'MECHANICAL'; % MECHANICAL | HEAT_TRANSFER | MESH_GENERATOR

                           % MECHANICAL - получение эффективных механических свойств с помощью решателя Abaqus
                           % HEAT_TRANSFER - получение эффективных свойств теплопереноса с помощью решателя Abaqus
                           % MESH_GENERATOR - только генерация сетки (без расчета)
                           
Mechanical_BC_TYPE         = 'SOFT'; % SOFT | HARD    % Тип граничных условий в механическом расчете

                           % SOFT - периодические граничные условия со свободной границей ячейки
                           % HARD - периодические граничные условия с фиксированной границей ячейки (использовать с большой осторожностью!)
                           
Constraint_Directions      = 'XYZ';    % Направления, задающие грани с фиксированной границей в случае Mechanical_BC_TYPE == HARD. Строка, состоящая из символов X, Y, Z.

Chemical_Shrinkage         = 'FALSE'; % TRUE | FALSE    % Расчет эффективных коэффициентов химической усадки помимо основных механических свойств

% ----------------------------------------- Свойства материала ------------------------------------------

% ДЛЯ МЕХАНИЧЕСКОГО И ТЕПЛОВОГО РАСЧЕТА

Fiber_rho                  = 1.78;    % Плотность волокна
Matrix_rho                 = 1.2;    % Плотность матрицы

% ДЛЯ МЕХАНИЧЕСКОГО РАСЧЕТА

% Свойства волокна
Fiber_E_L                  = 240;    % Модуль упругости в продольном направлении (L)
Fiber_E_T                  = 15;    % Модуль упругости в поперечном направлении (T)
Fiber_G_LT                 = 26;    % Модуль сдвига в плоскости LT
Fiber_nu_LT                = 0.267;    % Коэффициент Пуассона LT (nu_LT*E_T = nu_TL*E_L)
Fiber_nu_TT                = 0.485;    % Коэффициент Пуассона TT
Fiber_alpha_L              = -0.568;    % Коэффициент линейного теплового расширения в направлении L
Fiber_alpha_T              = 9.372;    % Коэффициент линейного теплового расширения в направлении T
Fiber_beta_L               = 0;    % Коэффициент химической усадки в направлении 1
Fiber_beta_T               = 0;    % Коэффициент химической усадки в направлении 2

% Свойства матрицы
Matrix_E                   = 3.5;    % Модуль упругости
Matrix_nu                  = 0.38;    % Коэффициент Пуассона
Matrix_alpha               = 70;    % Коэффициент линейного теплового расширения
Matrix_beta                = -0.01;    % Коэффициент химической усадки

% ДЛЯ ТЕПЛОВОГО РАСЧЕТА

% Свойства волокна
Fiber_Cp                   = 710;    % Удельная теплоемкость
Fiber_lambda_L             = 10;    % Коэффициент теплопроводности в продольном направлении (L)
Fiber_lambda_T             = 1;    % Коэффициент теплопроводности в поперечном направлении (T)

% Свойства матрицы
Matrix_Cp                  = 1200;    % Удельная теплоемкость
Matrix_lambda              = 0.2;    % Коэффициент теплопроводности

% ----------------------------------------- Параметры запуска -------------------------------------------

Work_Directory             = 'M:\Abaqus_Work';    % Рабочая папка для проведения расчета в Abaqus
CPU                        = 4;                   % Число используемых ядер для расчета в Abaqus

% -------------------------------------------------------------------------------------------------------

% #######################################################################################################
% ##                                                                                                   ##
% ##                                     КОНЕЦ НАСТРОЕК ПРОГРАММЫ                                      ##
% ##                                                                                                   ##
% #######################################################################################################

global ErrCode;
global Merge_Tolerance_Multiplier;
global software_version;
global software_date;
global software_year;

global Auto_Thickness_Multiplier;
global Mesh_Seed_M_Multiplier;

ErrCode = 0;
Merge_Tolerance_Multiplier = [];
software_version = [];
software_date = [];
software_year = [];

Auto_Thickness_Multiplier = [];
Mesh_Seed_M_Multiplier = [];

% Отсчет времени выполнения программы
tic;

% Инициализация базовых переменных
Init_Variables();

% Печать приветствия
Print_Greeting();

% Проверка параметров
if ((V_resin <= 0) || (V_resin >= 1))
    ErrCode = -1;
    fprintf (1, 'Недопустимое значение параметра V_resin !\n');
    fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
    toc;
    return;
end

if (Fiber_Diameter <= 0)
    ErrCode = -1;
    fprintf (1, 'Недопустимое значение параметра Fiber_Diameter !\n');
    fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
    toc;
    return;
end

switch Fiber_Packing
    case {'HEXAGONAL', 'SQUARE'}
        % Допустимые значения
    otherwise
        ErrCode = -1;
        fprintf (1, 'Недопустимое значение параметра Fiber_Packing !\n');
        fprintf (1, 'Разрешенные значения: HEXAGONAL, SQUARE\n');
        fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
        toc;
        return;
end

switch RVE_Thickness_Model
    case {'AUTO', 'SPECIFY'}
        % Допустимые значения
    otherwise
        ErrCode = -1;
        fprintf (1, 'Недопустимое значение параметра RVE_Thickness_Model !\n');
        fprintf (1, 'Разрешенные значения: AUTO, SPECIFY\n');
        fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
        toc;
        return;
end

if (RVE_Thickness_Value <= 0)
    ErrCode = -1;
    fprintf (1, 'Недопустимое значение параметра RVE_Thickness_Value !\n');
    fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
    toc;
    return;
end

switch Element_Order
    case {'LINEAR', 'QUADRATIC'}
        % Допустимые значения
    otherwise
        ErrCode = -1;
        fprintf (1, 'Недопустимое значение параметра Element_Order !\n');
        fprintf (1, 'Разрешенные значения: LINEAR, QUADRATIC\n');
        fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
        toc;
        return;
end

if (Mesh_Seed_Parameter ~= floor(Mesh_Seed_Parameter))
    ErrCode = -1;
    fprintf (1, 'Недопустимое значение параметра Mesh_Seed_Parameter !\n');
    fprintf (1, 'Параметр должен быть целым числом.\n');
    fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
    toc;
    return;
end

if (Mesh_Seed_Parameter < 1)
    ErrCode = -1;
    fprintf (1, 'Недопустимое значение параметра Mesh_Seed_Parameter !\n');
    fprintf (1, 'Параметр должен быть больше или равен единице.\n');
    fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
    toc;
    return;
end

if (N_Elements_High ~= floor(N_Elements_High))
    ErrCode = -1;
    fprintf (1, 'Недопустимое значение параметра N_Elements_High !\n');
    fprintf (1, 'Параметр должен быть целым числом.\n');
    fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
    toc;
    return;
end

if (N_Elements_High < 1)
    ErrCode = -1;
    fprintf (1, 'Недопустимое значение параметра N_Elements_High !\n');
    fprintf (1, 'Параметр должен быть больше или равен единице.\n');
    fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
    toc;
    return;
end

if (Element_Critical_Ratio <= 1)
    ErrCode = -1;
    fprintf (1, 'Недопустимое значение параметра Element_Critical_Ratio !\n');
    fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
    toc;
    return;
end

if (RVE_Array_1 ~= floor(RVE_Array_1))
    ErrCode = -1;
    fprintf (1, 'Недопустимое значение параметра RVE_Array_1 !\n');
    fprintf (1, 'Параметр должен быть целым числом.\n');
    fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
    toc;
    return;
end

if (RVE_Array_1 < 1)
    ErrCode = -1;
    fprintf (1, 'Недопустимое значение параметра RVE_Array_1 !\n');
    fprintf (1, 'Параметр должен быть больше или равен единице.\n');
    fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
    toc;
    return;
end

if (RVE_Array_2 ~= floor(RVE_Array_2))
    ErrCode = -1;
    fprintf (1, 'Недопустимое значение параметра RVE_Array_2 !\n');
    fprintf (1, 'Параметр должен быть целым числом.\n');
    fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
    toc;
    return;
end

if (RVE_Array_2 < 1)
    ErrCode = -1;
    fprintf (1, 'Недопустимое значение параметра RVE_Array_2 !\n');
    fprintf (1, 'Параметр должен быть больше или равен единице.\n');
    fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
    toc;
    return;
end

if (RVE_Array_3 ~= floor(RVE_Array_3))
    ErrCode = -1;
    fprintf (1, 'Недопустимое значение параметра RVE_Array_3 !\n');
    fprintf (1, 'Параметр должен быть целым числом.\n');
    fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
    toc;
    return;
end

if (RVE_Array_3 < 1)
    ErrCode = -1;
    fprintf (1, 'Недопустимое значение параметра RVE_Array_3 !\n');
    fprintf (1, 'Параметр должен быть больше или равен единице.\n');
    fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
    toc;
    return;
end

switch Analysis_Type
    case {'MECHANICAL', 'HEAT_TRANSFER', 'MESH_GENERATOR'}
        % Допустимые значения
    otherwise
        ErrCode = -1;
        fprintf (1, 'Недопустимое значение параметра Analysis_Type !\n');
        fprintf (1, 'Разрешенные значения: MECHANICAL, HEAT_TRANSFER, MESH_GENERATOR\n');
        fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
        toc;
        return;
end

switch Mechanical_BC_TYPE
    case {'SOFT', 'HARD'}
        % Допустимые значения
    otherwise
        ErrCode = -1;
        fprintf (1, 'Недопустимое значение параметра Mechanical_BC_TYPE !\n');
        fprintf (1, 'Разрешенные значения: SOFT, HARD\n');
        fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
        toc;
        return;
end

if ((numel(Constraint_Directions) < 1) || (numel(Constraint_Directions) > 3))
    ErrCode = -1;
    fprintf (1, 'Недопустимое значение параметра Constraint_Directions !\n');
    fprintf (1, 'Разрешенные значения: строка, состоящая из символов X, Y, Z.\n');
    fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
    toc;
    return;
end

for i=1:numel(Constraint_Directions)
    switch Constraint_Directions(i)
        case {'X', 'Y', 'Z'}
            % Допустимые значения
        otherwise
            ErrCode = -1;
            fprintf (1, 'Недопустимое значение параметра Constraint_Directions !\n');
            fprintf (1, 'Разрешенные значения: строка, состоящая из символов X, Y, Z.\n');
            fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
            toc;
            return;
    end
end

switch Chemical_Shrinkage
    case {'TRUE', 'FALSE'}
        % Допустимые значения
    otherwise
        ErrCode = -1;
        fprintf (1, 'Недопустимое значение параметра Chemical_Shrinkage !\n');
        fprintf (1, 'Разрешенные значения: TRUE, FALSE\n');
        fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
        toc;
        return;
end

if (CPU ~= floor(CPU))
    ErrCode = -1;
    fprintf (1, 'Недопустимое значение параметра CPU !\n');
    fprintf (1, 'Параметр должен быть целым числом.\n');
    fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
    toc;
    return;
end

if (CPU < 1)
    ErrCode = -1;
    fprintf (1, 'Недопустимое значение параметра CPU !\n');
    fprintf (1, 'Параметр должен быть больше или равен единице.\n');
    fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
    toc;
    return;
end

% Счетчики числа сообщений
N_Info = 0;
N_Warnings = 0;

% Анализ настроек программы
if (strcmp(Analysis_Type, 'MECHANICAL'))
    
    if (strcmp(Mechanical_BC_TYPE, 'HARD'))
        fprintf (1, 'ПРЕДУПРЕЖДЕНИЕ! В расчете используются периодические граничные условия с фиксированной границей\n');
        fprintf (1, '                ячейки (Mechanical_BC_TYPE = HARD). Требуется особое внимание при анализе\n');
        fprintf (1, '                полученных эффективных свойств.\n\n');
        N_Warnings = N_Warnings + 1;
    end
    
end

% Создание базовых точек
Points = Construct_Geometry(V_resin, Fiber_Diameter, Fiber_Packing);

if (ErrCode < 0)
    fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
    toc;
    return;
end

% Построение сетки
[NODES, ELEMENTS, RVE_Coordinates, Node_Merge_Tolerance] = Generate_Mesh(Fiber_Packing, Points, RVE_Thickness_Model, RVE_Thickness_Value, Element_Order, Mesh_Seed_Parameter, N_Elements_High, Element_Critical_Ratio, RVE_Array_1, RVE_Array_2, RVE_Array_3, Analysis_Type);

if (ErrCode < 0)
    fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
    toc;
    return;
end

% Корректировка Work_Directory
if (Work_Directory(length(Work_Directory)) == '\')
    Work_Directory = Work_Directory(1:length(Work_Directory)-1);
end

% Заполнение структуры со свойствами материала
Material_Properties.Fiber_E_1 = Fiber_E_L;
Material_Properties.Fiber_E_2 = Fiber_E_T;
Material_Properties.Fiber_E_3 = Fiber_E_T;
Material_Properties.Fiber_G_12 = Fiber_G_LT;
Material_Properties.Fiber_G_13 = Fiber_G_LT;
Material_Properties.Fiber_G_23 = Fiber_E_T/2/(1+Fiber_nu_TT);
Material_Properties.Fiber_Nu_12 = Fiber_nu_LT;
Material_Properties.Fiber_Nu_13 = Fiber_nu_LT;
Material_Properties.Fiber_Nu_23 = Fiber_nu_TT;
Material_Properties.Fiber_alpha_11 = Fiber_alpha_L;
Material_Properties.Fiber_alpha_22 = Fiber_alpha_T;
Material_Properties.Fiber_alpha_33 = Fiber_alpha_T;
Material_Properties.Fiber_beta_11 = Fiber_beta_L;
Material_Properties.Fiber_beta_22 = Fiber_beta_T;
Material_Properties.Fiber_beta_33 = Fiber_beta_T;
Material_Properties.Fiber_rho = Fiber_rho;
Material_Properties.Fiber_Cp = Fiber_Cp;
Material_Properties.Fiber_lambda_11 = Fiber_lambda_L;
Material_Properties.Fiber_lambda_22 = Fiber_lambda_T;
Material_Properties.Fiber_lambda_33 = Fiber_lambda_T;

Material_Properties.Matrix_E = Matrix_E;
Material_Properties.Matrix_nu = Matrix_nu;
Material_Properties.Matrix_alpha = Matrix_alpha;
Material_Properties.Matrix_beta = Matrix_beta;
Material_Properties.Matrix_rho = Matrix_rho;
Material_Properties.Matrix_Cp = Matrix_Cp;
Material_Properties.Matrix_lambda = Matrix_lambda;

% Проверка свойств материала
Check_Material_Properties(Material_Properties);

if (ErrCode < 0)
    fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
    toc;
    return;
end

% Данные для построения систем координат
Coordinate_Systems = Define_Coord_Systems();

% Ветвление по типу анализа
switch Analysis_Type
    
    case 'MECHANICAL'
        
        Mechanical_Procedure(Work_Directory, CPU, NODES, ELEMENTS, Material_Properties, Coordinate_Systems, RVE_Coordinates, Node_Merge_Tolerance, Chemical_Shrinkage, Mechanical_BC_TYPE, Constraint_Directions, V_resin);
        
        if (ErrCode < 0)
            fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
            toc;
            return;
        end
        
    case 'HEAT_TRANSFER'
        
        Heat_Transfer_Procedure(Work_Directory, CPU, NODES, ELEMENTS, Material_Properties, Coordinate_Systems, RVE_Coordinates, Node_Merge_Tolerance, V_resin);
        
        if (ErrCode < 0)
            fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
            toc;
            return;
        end
        
    case 'MESH_GENERATOR'
        
        Write_Input_Mesh(Work_Directory, NODES, ELEMENTS, Material_Properties, Coordinate_Systems);

        if (ErrCode < 0)
            fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
            toc;
            return;
        end
    
end

% Печать разделителя
Print_Delimiter();

% Сообщение об успешном завершении работы программы
fprintf (1, 'Работа программы завершена успешно!\n\n');

% Вывод числа предупреждений
if (N_Warnings > 0)
    fprintf (1, '\tПолучено предупреждений: %i\n', N_Warnings);
end

% Вывод числа информационных сообщений
if (N_Info > 0)
    fprintf (1, '\tПолучено информационных сообщений: %i\n', N_Info);
end

% Печать новой строки
if ((N_Warnings > 0) || (N_Info > 0))
    fprintf (1, '\n');
end

% Вывод времени выполнения программы
toc;
